## com.gargoylesoftware.htmlunit.html
Class HtmlCheckBoxInput

    java.lang.Object
      com.gargoylesoftware.htmlunit.html.DomNode
          com.gargoylesoftware.htmlunit.html.DomNamespaceNode
              com.gargoylesoftware.htmlunit.html.DomElement
                  com.gargoylesoftware.htmlunit.html.HtmlElement
                      com.gargoylesoftware.htmlunit.html.StyledElement
                          com.gargoylesoftware.htmlunit.html.ClickableElement
                              com.gargoylesoftware.htmlunit.html.HtmlInput
                                  com.gargoylesoftware.htmlunit.html.HtmlCheckBoxInput

All Implemented Interfaces:
  DisabledElement, SubmittableElement, java.io.Serializable, java.lang.Cloneable, org.w3c.dom.Element, org.w3c.dom.Node

    public class HtmlCheckBoxInput

extends HtmlInput

Wrapper for the HTML element "input".

Version:
  $Revision: 4854 $
Author:
  Mike Bowler, David K. Taylor, Jun Chen, Christian Sell, Marc Guillemot, Mike Bresnahan, Daniel Gredler, Ahmed Ashour
See Also:
  Serialized Form

Nested Class Summary

Nested classes/interfaces inherited from class com.gargoylesoftware.htmlunit.html.HtmlElement
`HtmlElement.ChildElementsIterator`

Nested classes/interfaces inherited from class com.gargoylesoftware.htmlunit.html.DomNode
`DomNode.ChildIterator, DomNode.DescendantElementsIterator`

Field Summary

Fields inherited from class com.gargoylesoftware.htmlunit.html.HtmlInput
`TAG_NAME`

Fields inherited from class com.gargoylesoftware.htmlunit.html.HtmlElement
`TAB_INDEX_OUT_OF_BOUNDS`

Fields inherited from class com.gargoylesoftware.htmlunit.html.DomElement
`ATTRIBUTE_NOT_DEFINED, ATTRIBUTE_VALUE_EMPTY`

Fields inherited from class com.gargoylesoftware.htmlunit.html.DomNode
`AS_TEXT_BLANK, AS_TEXT_BLOCK_SEPARATOR, AS_TEXT_NEW_LINE, AS_TEXT_TAB, PROPERTY_ELEMENT, READY_STATE_COMPLETE, READY_STATE_INTERACTIVE, READY_STATE_LOADED, READY_STATE_LOADING, READY_STATE_UNINITIALIZED`

Fields inherited from interface org.w3c.dom.Node

`ATTRIBUTE_NODE, CDATA_SECTION_NODE, COMMENT_NODE, DOCUMENT_FRAGMENT_NODE, DOCUMENT_NODE, DOCUMENT_POSITION_CONTAINED_BY, DOCUMENT_POSITION_CONTAINS, DOCUMENT_POSITION_DISCONNECTED, DOCUMENT_POSITION_FOLLOWING, DOCUMENT_POSITION_IMPLEMENTATION_SPECIFIC, DOCUMENT_POSITION_PRECEDING, DOCUMENT_TYPE_NODE, ELEMENT_NODE, ENTITY_NODE, ENTITY_REFERENCE_NODE, NOTATION_NODE, PROCESSING_INSTRUCTION_NODE, TEXT_NODE`

Method Summary
`java.lang.String` `asText()` A checkbox does not have a textual representation, but we invent one for it because it is useful for testing.
`protected Page` `doClickAction(Page defaultPage)` Override so that checkbox can change its state correctly when its click() method is called.
`boolean` `isDefaultChecked()` Returns the default checked state to use when this element gets reset, if applicable.
`protected boolean` `isStateUpdateFirst()` Both IE and Mozilla will first update the internal state of checkbox and then handle "onclick" event.
`protected void` `preventDefault()` This method is called if the current fired event is canceled by `preventDefault()` in FireFox, or by returning `false` in Internet Explorer.
`void` `reset()` Returns the value of this element to the default value or checked state (usually what it was at the time the page was loaded, unless it has been modified via JavaScript).
`Page` `setChecked(boolean isChecked)` Sets the "checked" attribute, returning the page that occupies this input's window after setting the attribute.
`void` `setDefaultChecked(boolean defaultChecked)` Sets the default checked state to use when this element gets reset, if applicable.
`void` `setDefaultValue(java.lang.String defaultValue)` Sets the default value to use when this element gets reset, if applicable.

Methods inherited from class com.gargoylesoftware.htmlunit.html.HtmlInput

`click, getAcceptAttribute, getAccessKeyAttribute, getAlignAttribute, getAltAttribute, getCheckedAttribute, getDefaultValue, getDisabledAttribute, getMaxLengthAttribute, getNameAttribute, getOnBlurAttribute, getOnChangeAttribute, getOnFocusAttribute, getOnSelectAttribute, getReadOnlyAttribute, getSizeAttribute, getSrcAttribute, getSubmitKeyValuePairs, getTabIndexAttribute, getTypeAttribute, getUseMapAttribute, getValueAttribute, isChecked, isDisabled, isReadOnly, setDefaultValue, setReadOnly, setValueAttribute`

Methods inherited from class com.gargoylesoftware.htmlunit.html.StyledElement
`getClassAttribute, getIdAttribute, getStyleAttribute, getTitleAttribute`

Methods inherited from class com.gargoylesoftware.htmlunit.html.HtmlElement

`addHtmlAttributeChangeListener, appendChildIfNoneExists, blur, checkChildHierarchy, click, click, click, dblClick, dblClick, doType, fireEvent, fireEvent, fireHtmlAttributeAdded, fireHtmlAttributeRemoved, fireHtmlAttributeReplaced, focus, getChildElements, getElementById, getElementsByAttribute, getEnclosingElement, getEnclosingForm, getEnclosingFormOrDie, getEventHandler, getHtmlElementsByTagName, getHtmlElementsByTagNames, getId, getLangAttribute, getNodeName, getOnClickAttribute, getOnDblClickAttribute, getOneHtmlElementByAttribute, getOnKeyDownAttribute, getOnKeyPressAttribute, getOnKeyUpAttribute, getOnMouseDownAttribute, getOnMouseMoveAttribute, getOnMouseOutAttribute, getOnMouseOverAttribute, getOnMouseUpAttribute, getTabIndex, getTextDirectionAttribute, getXmlLangAttribute, hasHtmlElementWithId, isAttributeCaseSensitive, isSubmittableByEnter, mouseDown, mouseDown, mouseMove, mouseMove, mouseOut, mouseOut, mouseOver, mouseOver, mouseUp, mouseUp, removeAttribute, removeChild, removeEventHandler, removeHtmlAttributeChangeListener, rightClick, rightClick, setAttributeNS, setEventHandler, setEventHandler, setId, toString, type, type, type, type`

Methods inherited from class com.gargoylesoftware.htmlunit.html.DomElement

`cloneNode, getAttribute, getAttributeNode, getAttributeNodeNS, getAttributeNS, getAttributes, getAttributesMap, getElementsByTagName, getElementsByTagNameNS, getNodeType, getSchemaTypeInfo, getTagName, hasAttribute, hasAttributeNS, hasAttributes, isEmptyXmlTagExpanded, namespaces, printOpeningTagContentAsXml, printXml, removeAttributeNode, removeAttributeNS, setAttribute, setAttributeNode, setAttributeNodeNS, setIdAttribute, setIdAttributeNode, setIdAttributeNS`

Methods inherited from class com.gargoylesoftware.htmlunit.html.DomNamespaceNode
`getLocalName, getNamespaceURI, getPrefix, getQualifiedName, setPrefix`

Methods inherited from class com.gargoylesoftware.htmlunit.html.DomNode

`addDomChangeListener, appendChild, asXml, compareDocumentPosition, fireNodeAdded, fireNodeDeleted, getAllHtmlChildElements, getAncestors, getBaseURI, getByXPath, getCanonicalXPath, getChildNodes, getChildren, getEndColumnNumber, getEndLineNumber, getFeature, getFirstByXPath, getFirstChild, getLastChild, getNextSibling, getNodeValue, getOwnerDocument, getPage, getParentNode, getPreviousSibling, getReadyState, getScriptObject, getStartColumnNumber, getStartLineNumber, getTextContent, getUserData, hasChildNodes, insertBefore, insertBefore, isAncestorOf, isBlock, isDefaultNamespace, isDisplayed, isEqualNode, isSameNode, isSupported, isTrimmedText, lookupNamespaceURI, lookupPrefix, normalize, notifyIncorrectness, onAddedToPage, onAllChildrenAddedToPage, printChildrenAsXml, remove, removeAllChildren, removeChild, removeDomChangeListener, replace, replaceChild, selectNodes, selectSingleNode, setNextSibling, setNodeValue, setParentNode, setPreviousSibling, setReadyState, setScriptObject, setTextContent, setUserData`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Methods inherited from interface org.w3c.dom.Node

`appendChild, compareDocumentPosition, getBaseURI, getChildNodes, getFeature, getFirstChild, getLastChild, getLocalName, getNamespaceURI, getNextSibling, getNodeValue, getOwnerDocument, getParentNode, getPrefix, getPreviousSibling, getTextContent, getUserData, hasChildNodes, insertBefore, isDefaultNamespace, isEqualNode, isSameNode, isSupported, lookupNamespaceURI, lookupPrefix, normalize, removeChild, replaceChild, setNodeValue, setPrefix, setTextContent, setUserData`

Method Detail

### reset

    public void reset()

  Returns the value of this element to the default value or checked state (usually what it was at the time the page was loaded, unless it has been modified via JavaScript).

  Specified by:
    `reset` in interface `SubmittableElement`
  Overrides:
    `reset` in class `HtmlInput`
  See Also:
    `SubmittableElement.reset()`

### setChecked

    public Page setChecked(boolean isChecked)

  Sets the "checked" attribute, returning the page that occupies this input's window after setting the attribute. Note that the returned page may or may not be the original page, depending on the presence of JavaScript event handlers, etc.

  Overrides:
    `setChecked` in class `HtmlInput`
  Parameters:
    `isChecked` - `true` if this element is to be selected
  Returns:
    the page that occupies this input's window after setting the attribute

### asText

    public java.lang.String asText()

  A checkbox does not have a textual representation, but we invent one for it because it is useful for testing.

  Overrides:
    `asText` in class `DomNode`
  Returns:
    "checked" or "unchecked" according to the radio state

### doClickAction

    protected Page doClickAction(Page defaultPage)
                          throws java.io.IOException

  Override so that checkbox can change its state correctly when its click() method is called.

  This method will be called if there either wasn't an `onclick` handler, or if there was one, but the result of that handler wasn't `false`. This is the default behavior of clicking the element.

  The default implementation returns the current page. Subclasses requiring different behavior (like `HtmlSubmitInput`) will override this method.

  Overrides:
    `doClickAction` in class `HtmlElement`
  Parameters:
    `defaultPage` - the default page to return if the action does not load a new page
  Returns:
    the page that is currently loaded after execution of this method
  Throws:
    `java.io.IOException` - if an IO error occurs

### isStateUpdateFirst

    protected boolean isStateUpdateFirst()

  Both IE and Mozilla will first update the internal state of checkbox and then handle "onclick" event. Returns `true` if state updates should be done before onclick event handling. This method returns `false` by default, and is expected to be overridden to return `true` by derived classes like `HtmlCheckBoxInput`.

  Overrides:
    `isStateUpdateFirst` in class `HtmlElement`
  Returns:
    `true` if state updates should be done before onclick event handling

### preventDefault

    protected void preventDefault()

  This method is called if the current fired event is canceled by `preventDefault()` in FireFox, or by returning `false` in Internet Explorer. The default implementation does nothing.

  Overrides:
    `preventDefault` in class `HtmlElement`

### setDefaultValue

    public void setDefaultValue(java.lang.String defaultValue)

  Sets the default value to use when this element gets reset, if applicable. Also sets the value attribute when emulating Netscape browsers. Also sets the value to the new default value.

  Specified by:
    `setDefaultValue` in interface `SubmittableElement`
  Overrides:
    `setDefaultValue` in class `HtmlInput`
  Parameters:
    `defaultValue` - the default value to use when this element gets reset, if applicable
  See Also:
    `SubmittableElement.setDefaultValue(String)`

### setDefaultChecked

    public void setDefaultChecked(boolean defaultChecked)

  Sets the default checked state to use when this element gets reset, if applicable. The default implementation is empty; only checkboxes and radio buttons really care what the default checked value is.

  Specified by:
    `setDefaultChecked` in interface `SubmittableElement`
  Overrides:
    `setDefaultChecked` in class `HtmlInput`
  Parameters:
    `defaultChecked` - the default checked state to use when this element gets reset, if applicable
  See Also:
    `SubmittableElement.setDefaultChecked(boolean)`

### isDefaultChecked

    public boolean isDefaultChecked()

  Returns the default checked state to use when this element gets reset, if applicable. The default implementation returns `false`; only checkboxes and radio buttons really care what the default checked value is.

  Specified by:
    `isDefaultChecked` in interface `SubmittableElement`
  Overrides:
    `isDefaultChecked` in class `HtmlInput`
  Returns:
    the default checked state to use when this element gets reset, if applicable
  See Also:
    `SubmittableElement.isDefaultChecked()`

Copyright © 2002-2011 Gargoyle Software Inc.. All Rights Reserved.